/* 
Mikroekonometria 
Zajęcia 5 - Heteroskedastycznosc
CC BY: Wiktor Budziński
*/

// Zadanie 1. Przeanalizuj problem heteroskedastyczności wykorzystując test Breusha-Pagana w różnych wersjach

cd "C:\Users\budzi\Documents\ME2024\ME4"
use me_wine_update.dta, clear

global vintage Vintage91-Vintage99
global region Napavalley bayareacentral sonoma southcoast carneros sierrafoothills mendocinolake washington 
global variety Nonvarietal Pinotnoir Cabernet Merlot Shyrah 
global type Reserve Vineyard Estate 

reg LogPrice LogCases c.LogCases#i.Variety c.LogCases#i.washington Score c.Score#i.Variety c.Score#i.washington ScoreSq Age c.Age#i.Variety c.Age#i.washington $region $variety $type $vintage

// Analiza wizualna

twoway scatter reszty5 Cases || qfit reszty5 Cases
twoway scatter reszty5 Score || qfit reszty5 Score

estat hettest // Defaultowy test Breusha-Pagana. Testuje czy wariancja zależy od wartości dopasowanych za pomocą MNK
estat hettest LogCases Score // Testujemy czy wariancja zależy od wybranych zmiennych
estat hettest , rhs // Testujemy czy wariancja zależy od wszystkich zmiennych objaśniajacych
estat hettest , rhs iid // Dodajemy opcja iid, jest to inna wersja testu, która nie zakłada normalnosci reszt / składnika losowego
estat hettest , rhs fstat // Jeszcze inna wersja, również nie zakłada normalności reszt / składnika losowego

// Zadanie 2. Dokonaj estymacji modelu regresji liniowej wykorzystując odporne macierze kowariancji

reg LogPrice LogCases c.LogCases#i.Variety c.LogCases#i.washington Score c.Score#i.Variety c.Score#i.washington ScoreSq Age c.Age#i.Variety c.Age#i.washington $region $variety $type $vintage, vce(robust) //Macierz White'a
// Dwie inne wersje odpornych macierzy kowariancji, bardzo podobne do macierzy White'a
reg LogPrice LogCases c.LogCases#i.Variety c.LogCases#i.washington Score c.Score#i.Variety c.Score#i.washington ScoreSq Age c.Age#i.Variety c.Age#i.washington $region $variety $type $vintage, vce(hc2) 
reg LogPrice LogCases c.LogCases#i.Variety c.LogCases#i.washington Score c.Score#i.Variety c.Score#i.washington ScoreSq Age c.Age#i.Variety c.Age#i.washington $region $variety $type $vintage, vce(hc3) 


// Zadanie 3.1 Dokonaj estymacji modelu regresji liniowej przy użyciu MNW 

// MNW
// Model analogiczny do MNK
hetregress LogPrice LogCases Score ScoreSq Age $region $variety $type $vintage

// Zadanie 3.2 Rozszerz model o bezpośrednie modelowanie heteroskedastyczności

hetregress LogPrice LogCases Score ScoreSq Age $region $variety $type $vintage, het(LogCases Score ScoreSq Age $region $variety $type $vintage)

// Zadanie 4. 
///// Efekty krancowe

// Niezbyt interesujące
margins, dydx(LogCases Age)
// To dziala prawidlowo dla Age (zmienna nieprzeksztalcone)
// Policz efekt krańcowy mówiący jak wzrost zmiennej Age  o jednostkę wpłynie na zmianę ceny
margins, dydx(LogCases Age) expression(exp(predict(xb)+0.5*predict(sigma)^2))
// Jesli interesuje nas elastycznosc:
margins, eyex(Age) expression(exp(predict(xb)+0.5*predict(sigma)^2))

// Policz efekt krańcowy mówiący jak wzrost zmiennej Cases o jeden procent wpłynie na procentową zmianę ceny
// Cases jest juz przeksztalcone logarytmicznie, wiec liczymy
margins, eydx(LogCases) expression(exp(predict(xb)+0.5*predict(sigma)^2))

// W modelu bez heteroskedastycznosci
hetregress LogPrice LogCases Score ScoreSq Age $region $variety $type $vintage
margins, eydx(LogCases) expression(exp(predict(xb)+0.5*predict(sigma)^2))

// Efekty krancowe dla roznych wartosci zmiennej 
quietly hetregress LogPrice LogCases Score ScoreSq Age $region $variety $type $vintage, het(LogCases Score ScoreSq Age $region $variety $type $vintage)

margins, eydx(LogCases) expression(exp(predict(xb)+0.5*predict(sigma)^2)) at(LogCases = 0) 

// Cases od 30 do 70
margins, eydx(LogCases) expression(exp(predict(xb)+0.5*predict(sigma)^2)) at(LogCases = (3.4011974, 3.6888795, 3.912023, 4.0943446, 4.2484952)) 
marginsplot // Malo interesujace - w modelu log-log elastycznosc stala
// Zobaczmy efekt krancowy dla age
margins, dydx(Age) expression(exp(predict(xb)+0.5*predict(sigma)^2)) at(Age = (1, 2, 3, 4, 5)) 
marginsplot

// Efekty krancowe mozna tez liczyc dla srednich wartosci w probie
	// Szybsze obliczenia
margins, eydx(LogCases) expression(exp(predict(xb)+0.5*predict(sigma)^2)) atmeans

