/* 
Mikroekonometria 
Zajęcia 5 - MNW / Regresja liniowa z heteroskedastycznoscia
// Efekty krancowe - symulacja
CC BY: Wiktor Budziński
*/

clear all
cls
set seed 10311563
// Wykorzystaj metody symulacyjne by sprawdzić czy kontrolowanie heteroskedastyczności faktycznie może wpłynąć na nasze wnioskowanie

set obs 2000 // ustawiamy liczbę obserwacji
generate logx = runiform(0,2) // x o wartościach losowe z rozkładu jednostajnego [0,2]
generate eps1 = rnormal() // eps1 (błąd) o wartościach losowych z rozkładu standardowego normalnego
gen sigma = exp(-0.5*logx)
replace eps1 = eps1 * sigma // eps1 będzie większy (co do wartości bezwzględnej) dla obserwacji o większych wartościach x
generate logy = 2 + 0.25*logx + eps1 // y zależy od wartości x i eps1, więc wariancja składnika losowego zależy od x 

// Bez kontrolowania heteroskedastycznosci
hetreg logy logx
margins, eydx(logx) expression(exp(predict(xb)+0.5*predict(sigma)^2))

hetreg logy logx, het(logx)
margins, eydx(logx) expression(exp(predict(xb)+0.5*predict(sigma)^2))


